// Dart client
import 'dart:core';
import 'dart:io';
import 'dart:math';
import 'dart:convert';

void test() async {
  try {
    Random r = new Random();
    String key = base64.encode(List<int>.generate(8, (_) => r.nextInt(255)));

    HttpClient client = HttpClient(/* optional security context here */);
    HttpClientRequest request = await client.post('127.0.0.1', 4442,
        '/foo/ws?peer-id=myapikey'); // form the correct url here
    request.headers.add('Connection', 'upgrade');
    request.headers.add('Upgrade', 'websocket');
    request.headers
        .add('sec-websocket-version', '13'); // insert the correct version here
    request.headers.add('sec-websocket-key', key);

    HttpClientResponse response = await request.close();
    // todo check the status code, key etc
    Socket socket = await response.detachSocket();

    WebSocket ws = WebSocket.fromUpgradedSocket(
      socket,
      serverSide: false,
    );

    ws.listen((data) {
        print('Recivied data: ' + data);
      }, onDone: () {
        print('Closed by server!');
      });
    print('open');
  } catch (e) {
    print('e' + e.toString());
  }
}

void main() async {
  await test();
}
